/*
 *  linux/include/asm-arm/arch-omaha/hardware.h
 *
 *  This file contains the hardware definitions of Omaha.
 *
 *  Copyright (C) 1999-2002 ARM Limited.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __ASM_ARCH_HARDWARE_H
#define __ASM_ARCH_HARDWARE_H

#include <asm/sizes.h>
#include <asm/arch/platform.h>

/*
 * Where in virtual memory the IO devices (timers, system controllers
 * and so on)
 */
#define IO_BASE			0xE0000000                 // VA of IO 
#define IO_SIZE			0x1B000000                 // How much?
#define IO_START		0x00000000		   // PA of IO

/* macro to get at IO space when running virtually */
#define IO_ADDRESS(x) (x + IO_BASE) 

#endif

